aboutsummaryrefslogtreecommitdiffstats
path: root/tests/auth-logindisabled
diff options
context:
space:
mode:
authorGuilhem Moulin <guilhem@fripost.org>2019-11-10 03:18:26 +0100
committerGuilhem Moulin <guilhem@fripost.org>2019-11-13 06:23:57 +0100
commit78522acced782587b3768f3fb57f2f25cb905754 (patch)
tree376fd984327ebc453fbdae0c9f821cb0b87e6467 /tests/auth-logindisabled
parent67440844c422ee30b31df9a46a7f99ac0e833add (diff)
Test suite: add new tests for authentication.
This can't be done with `doveadm exec imap`, so the IMAPd needs to bind to TCP port 10143 on the loopback interface. Also, no longer pass ‘imap_capability’ Dovecot setting explicitely to `doveadm exec imap`; changed tests/sync-live-crippled to use type=imap instead of type=tunnel.
Diffstat (limited to 'tests/auth-logindisabled')
l---------tests/auth-logindisabled/interimap.remote1
-rw-r--r--tests/auth-logindisabled/remote.conf4
-rw-r--r--tests/auth-logindisabled/t16
3 files changed, 21 insertions, 0 deletions
diff --git a/tests/auth-logindisabled/interimap.remote b/tests/auth-logindisabled/interimap.remote
new file mode 120000
index 0000000..a4ea3f3
--- /dev/null
+++ b/tests/auth-logindisabled/interimap.remote
@@ -0,0 +1 @@
+../auth-sasl-plain/interimap.remote \ No newline at end of file
diff --git a/tests/auth-logindisabled/remote.conf b/tests/auth-logindisabled/remote.conf
new file mode 100644
index 0000000..1f02afe
--- /dev/null
+++ b/tests/auth-logindisabled/remote.conf
@@ -0,0 +1,4 @@
+!include conf.d/imapd.conf
+
+# trick dovecot into treating local connections as insecure
+imap_capability = +LOGINDISABLED
diff --git a/tests/auth-logindisabled/t b/tests/auth-logindisabled/t
new file mode 100644
index 0000000..0bcd0d6
--- /dev/null
+++ b/tests/auth-logindisabled/t
@@ -0,0 +1,16 @@
+! interimap --debug || error
+
+# double check the presence of 'LOGINDISABLED' in the preauth capability list
+grep -oE -m1 '^remote: S: \* OK \[CAPABILITY IMAP4rev1( [^]]*)? AUTH=[^]]*\]' <"$STDERR" >"$TMPDIR/capability"
+
+sed -ri 's/^remote: S: \* OK \[CAPABILITY (.*)\]$/\1/' "$TMPDIR/capability"
+tr " " "\\n" <"$TMPDIR/capability" >"$TMPDIR/capabilities"
+grep -Fx "IMAP4rev1" <"$TMPDIR/capabilities" || error
+grep -Fx "LOGINDISABLED" <"$TMPDIR/capabilities" || error
+! grep -Fx "STARTTLS" <"$TMPDIR/capabilities" || error # otherwise we'd try to upgrade the connectionn
+
+# make sure we didn't send any credentials
+grep -Fx "remote: ERROR: Logins are disabled." <"$STDERR" || error
+! grep -E "^remote: C: .* (AUTHENTICATE|LOGIN) " <"$STDERR" || error
+
+# vim: set filetype=sh :